VERSION 5.00
Begin VB.UserControl JustifyVer2 
   BackColor       =   &H00FFFFFF&
   ClientHeight    =   2160
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2160
   DrawStyle       =   2  'Dot
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   16.8
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H000000FF&
   PropertyPages   =   "Justifyver2ctl.ctx":0000
   ScaleHeight     =   180
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   180
   ToolboxBitmap   =   "Justifyver2ctl.ctx":003E
End
Attribute VB_Name = "JustifyVer2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_HelpID = 1
Attribute VB_Description = "Access Justification Control ver2"
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
    Option Explicit
    
    'First of all, if you must throw stones, use small ones! :-)
    'This is my Second ActiveX control and I knew nothing of ActiveX
    'when I started..and it shows.
    '
    '
    'If you are trying to learn how to create ActiveX controls
    'then I would suggest you consider purchasing
    'Rod Stephens' book "Custom Control Library". This book
    'has been an invaluable tool, highly recommended!
    '
    'Name:                  Justified Text Control
    'Created by:            Stephen Lebans & Pedro Gil
    'Date:                  Aug 01, 1999
    'Time:                  10:02:36pm
    'Feedback:              macarthu@nbnet.nb.ca
    'My Web Page:           http://www.geocities.com/~slebans
    '
        
    'A large percentage of ActiveX controls do not function properly
    'within the VBA Access environment. A lot of it has to do
    'with differences in the Extender and Ambient control properties.
    'It took a lot of trial and error to get this control to
    'work in both Form and Report views. If you find that you
    'have to make a change for it to work in your environment
    'please let me know so that I can incorporate it into the next
    'release.
    
    'Bugs:
    'Only works with True Type Fonts. OK it does work with some
    'Bitmap fonts, but for the best accuracy use True Type.
    '
    'Changed from Print to TextOut for compatability
    'Print causes an OverFlow error for a UserDrawn Control
    'in the VB IDE. This is an acknowledged Bug by Microsoft.
  
    'In the VB IDE the Font color displays properly
    'but prints in Black only. This is a know bug from older
    'version of Visual Basic. I thought/believed it was now
    'Fixed. I really can't see using this control in VB
    'because it would make more sense to use the routines directly
    'in your code. Anyhow, if for some reason you do need to
    'use this control in VB, probably just bracket the TextOut
    'call with SetTextColor calls to set and reset the DC's current
    'selection for Forecolor.
    '
    '
    'Enjoy
    'Stephen Lebans
    
    '***************Code Start***************
    
    
    ' *****************
    ' Enumerated types.
    ' *****************
    
    ' Horizontal alignment.
    Enum text_HAlignment
        Left_HAlign
        Center_HAlign
        Right_HAlign
        Justify_HAlign
    End Enum
      
    
    ' ***********************
    'Default Property Values:
    'Not used in this version.
    Const m_def_testbound = 0
    
    'Sorry for the line length. I tried several ways to build the
    'string and VB wouldn't allow me to assign it. I gave up! :-(
    Const m_def_Caption = "Justified Text Control. Double Click on this Control, or Right Click and Select Properties. Remember, under the DATA tab, there is a ControlSource property, you can select a Field, or enter an Expression to bind this Control to."
  
    Const m_def_BackColor = vbWhite
    Const m_def_ForeColor = vbBlack
    
    Const m_def_FontName = "Arial"
    Const m_def_FontSize = 9
    Const m_def_FontBold = False
    Const m_def_MLines = True
    
    'Used to ask System for the Logical pixels/inch in Y axis
    Const LOGPIXELSY = 90

    'Property Variables:
    'Not used here
    Dim m_testbound As Variant
    
    'This is the actual string we display
    Dim m_Caption As String
    
    'Flag to set multiple lines Yes/No
    Dim m_MLines As Boolean
    
    'Holds the current screen resolution
    Dim lngYdpi As Long
    
    'Temporary Information Context for Screen info.
    Dim lngIc As Long
    
    'Calculate screen Font height
    Dim fHeight As Long
     
    'Event Declarations:
    Event GetDataMember(DataMember As String, Data As Object) 'MappingInfo=UserControl,UserControl,-1,GetDataMember
    
    'Left out for this version
    Event Click() 'MappingInfo=UserControl,UserControl,-1,Click
    Event DblClick() 'MappingInfo=UserControl,UserControl,-1,DblClick
    
    'Used to tell Paint event whether we are redrawing or not.
    Private skip_redraw As Boolean
    
    'I needed a font constant.
    'Without the constant, I was generating a
    'RunTime error on a GUI Cut & Paste operation.
    'If anyone knows why I would really appreciate an Email! :-)
    Dim m_def_Font As StdFont
    
    'Allow users to change font in Access
    Private WithEvents mFont As StdFont
Attribute mFont.VB_VarHelpID = -1

'Some Default Property Values:
Const m_def_HAlignment = Justify_HAlign
Const m_def_MarginTop = 2
Const m_def_MarginBottom = 2
Const m_def_MarginLeft = 2
Const m_def_MarginRight = 2
Const m_def_MarginBox = 2
Const m_def_ExtraLineSpacing = 0
Const m_def_ParagraphIndent = 0
'Property Variables:
Dim m_HAlignment As text_HAlignment
Dim m_MarginTop As Integer
Dim m_MarginBottom As Integer
Dim m_MarginLeft As Integer
Dim m_MarginRight As Integer
Dim m_MarginBox As Integer
Dim m_ExtraLineSpacing As Integer
Dim m_ParagraphIndent As Integer


' *********************************************
' Show the About dialog.
' *********************************************
Public Sub ShowAbout()
Attribute ShowAbout.VB_Description = "Displays the About dialog."
Attribute ShowAbout.VB_UserMemId = -552
Dim frm As New AboutDialog
  frm.Show vbModal
  Set frm = Nothing
End Sub
   
Public Property Get MultipleLines() As Boolean
'property that allows multiple line
  MultipleLines = m_MLines
End Property

Public Property Let MultipleLines(ByVal New_MultipleLines As Boolean)
  m_MLines = New_MultipleLines
  PropertyChanged "MultipleLines"
  UserControl_Paint   ' Redraw.
End Property

'Setup font as Arial 9 on control initialize
Private Sub UserControl_Initialize()
  Set mFont = New StdFont
  With mFont
    .Name = m_def_FontName
    .SIZE = m_def_FontSize
  End With
  
  Set UserControl.Font = mFont
  'Setup constant font  :-)
  Set m_def_Font = New StdFont
  With m_def_Font
    .Name = m_def_FontName
    .SIZE = m_def_FontSize
  End With
    'fixes Cut&Paste Access problem
    'I had a lot of problems getting the Font property to
    'function in Access. Above works. :-)
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
Dim varBack As Variant
Dim varFore As Variant

    skip_redraw = True
    m_Caption = m_def_Caption
    m_HAlignment = m_def_HAlignment
    m_MLines = m_def_MLines
  
    '**********************
    'error code to handle if no ambient Fore or Back Props
    On Error Resume Next
    varBack = Ambient.BackColor
    If Not IsNull(varBack) Then
        UserControl.BackColor = Ambient.BackColor
    Else
        UserControl.BackColor = m_def_BackColor
    End If
    On Error Resume Next
    varFore = Ambient.ForeColor
    If Not IsNull(varFore) Then
        UserControl.ForeColor = Ambient.ForeColor
    Else
        UserControl.ForeColor = m_def_ForeColor
    End If
    '*************************
    m_Caption = m_def_Caption
    m_testbound = m_def_testbound
  
    Set mFont = UserControl.Font
  
    m_MarginTop = m_def_MarginTop
    m_MarginBottom = m_def_MarginBottom
    m_MarginLeft = m_def_MarginLeft
    m_MarginRight = m_def_MarginRight
    m_MarginBox = m_def_MarginBox
    m_ExtraLineSpacing = m_def_ExtraLineSpacing
    m_ParagraphIndent = m_def_ParagraphIndent
    m_HAlignment = m_def_HAlignment

skip_redraw = False
UserControl_Paint   ' Redraw.
End Sub
    
Private Sub UserControl_Paint()
    
  Dim newfont As Long
  Dim oldfont As Long
  Dim lngret As Long
  
    
  ' Do nothing if we're loading.
  If skip_redraw Then Exit Sub
  ' Start from scratch..let's clear the screen.
  Cls
  
  'Check Caption string. If it's Empty or Null
  'then Exit Sub
   If Caption = "" Then Exit Sub
   If IsNull(Caption) Then Exit Sub
  
  'Modified to allow for different screen resolutions
  'and printer output. Needed to Calculate Font size
  lngIc = CreateIC("DISPLAY", vbNullString, vbNullString, vbNullString)
  If lngIc <> 0 Then
    lngYdpi = GetDeviceCaps(lngIc, LOGPIXELSY)
    DeleteDC (lngIc)
  Else
    lngYdpi = 120 'Default average value
  End If
   
  'Calculate/Convert requested Font Height
  'into Font's Device Coordinate space
  fHeight = MulDiv(Font.SIZE, lngYdpi, 72)
  
  'We use a negative value to signify
  'to the CreateFont function that we want a Glyph
  'outline of this size not a bounding box.
  newfont = CreateFont(-fHeight, 0, _
      0, 0, Font.Bold, _
      Font.Italic, Font.Underline, _
      Font.Strikethrough, 0, 0, _
       0, 0, 0, Font.Name)
      
  ' Select the new font.
  oldfont = SelectObject(hdc, newfont)
  
 
  'This calls the main print routine
  lngret = JustifyText(hdc, Caption)
  If lngret = False Then
    MsgBox ("Print Routine Failed")
    Stop
  End If
  
  ' Restore the original font.
  newfont = SelectObject(hdc, oldfont)
  DeleteObject newfont
    
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    'Don't redraw until all properties are loaded
    skip_redraw = True
  
    UserControl.ForeColor = PropBag.ReadProperty("ForeColor", m_def_ForeColor)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", m_def_BackColor)
    Set mFont = PropBag.ReadProperty("Font", m_def_Font) 'UserControl.Font)
    m_Caption = PropBag.ReadProperty("Caption", m_def_Caption)
    m_testbound = PropBag.ReadProperty("testbound", m_def_testbound)
  
    m_MLines = PropBag.ReadProperty("MultipleLines", m_def_MLines)
 
    m_MarginTop = PropBag.ReadProperty("MarginTop", m_def_MarginTop)
    m_MarginBottom = PropBag.ReadProperty("MarginBottom", m_def_MarginBottom)
    m_MarginLeft = PropBag.ReadProperty("MarginLeft", m_def_MarginLeft)
    m_MarginRight = PropBag.ReadProperty("MarginRight", m_def_MarginRight)
    m_MarginBox = PropBag.ReadProperty("MarginBox", m_def_MarginBox)
    m_ExtraLineSpacing = PropBag.ReadProperty("ExtraLineSpacing", m_def_ExtraLineSpacing)
    m_ParagraphIndent = PropBag.ReadProperty("ParagraphIndent", m_def_ParagraphIndent)
    m_HAlignment = PropBag.ReadProperty("HAlignment", m_def_HAlignment)
skip_redraw = False
UserControl_Paint   ' Redraw.
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  
  Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, m_def_ForeColor)
  Call PropBag.WriteProperty("BackColor", UserControl.BackColor, m_def_BackColor)
  Call PropBag.WriteProperty("Caption", m_Caption, m_def_Caption)
  Call PropBag.WriteProperty("testbound", m_testbound, m_def_testbound)
  Call PropBag.WriteProperty("Font", mFont, m_def_Font)
 
  Call PropBag.WriteProperty("MultipleLines", m_MLines, m_def_MLines)
  Call PropBag.WriteProperty("MarginTop", m_MarginTop, m_def_MarginTop)
  Call PropBag.WriteProperty("MarginBottom", m_MarginBottom, m_def_MarginBottom)
  Call PropBag.WriteProperty("MarginLeft", m_MarginLeft, m_def_MarginLeft)
  Call PropBag.WriteProperty("MarginRight", m_MarginRight, m_def_MarginRight)
  Call PropBag.WriteProperty("MarginBox", m_MarginBox, m_def_MarginBox)
  Call PropBag.WriteProperty("ExtraLineSpacing", m_ExtraLineSpacing, m_def_ExtraLineSpacing)
  Call PropBag.WriteProperty("ParagraphIndent", m_ParagraphIndent, m_def_ParagraphIndent)
  Call PropBag.WriteProperty("HAlignment", m_HAlignment, m_def_HAlignment)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "The foreground color used to display the Caption."
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = "StandardColor"
  ForeColor = UserControl.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
  UserControl.ForeColor() = New_ForeColor
  PropertyChanged "ForeColor"
  'UserControl_Paint   ' Redraw.
End Property

'Private Sub UserControl_Click()
'  RaiseEvent Click
'End Sub
'Private Sub UserControl_DblClick()
'  RaiseEvent DblClick
'End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute BackColor.VB_ProcData.VB_Invoke_Property = "StandardColor"
  BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
  UserControl.BackColor() = New_BackColor
  PropertyChanged "BackColor"
  'UserControl_Paint   ' Redraw.
End Property

Public Property Get Font() As StdFont
Attribute Font.VB_ProcData.VB_Invoke_Property = "StandardFont"
Attribute Font.VB_UserMemId = -512
  Set Font = mFont
End Property

Public Property Set Font(mnewfont As StdFont)
With mFont
  .Bold = mnewfont.Bold
  .Italic = mnewfont.Italic
  .Name = mnewfont.Name
  .SIZE = mnewfont.SIZE
End With
PropertyChanged "Font"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,DataMembers
Public Property Get DataMembers() As DataMembers
Attribute DataMembers.VB_Description = "Returns a collection of data members to show at design time for this data source."
  Set DataMembers = UserControl.DataMembers
  'UserControl_Paint   ' Redraw. DIDN"T WORK!!! 9:51 ver 11
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,DataMemberChanged
Public Sub DataMemberChanged(ByVal DataMember As String)
Attribute DataMemberChanged.VB_Description = "Notify data consumers that a data member of this data source has changed."
  UserControl.DataMemberChanged DataMember
End Sub

Private Sub UserControl_GetDataMember(DataMember As String, Data As Object)
  RaiseEvent GetDataMember(DataMember, Data)
  UserControl_Paint   ' Redraw.
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,
Public Property Get Caption() As String
Attribute Caption.VB_Description = "The text displayed in the label or data field if bound."
Attribute Caption.VB_ProcData.VB_Invoke_Property = "General"
Attribute Caption.VB_MemberFlags = "24"
  Caption = m_Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
  m_Caption = New_Caption
  PropertyChanged "Caption"
  UserControl_Paint   ' Redraw.
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14,0,0,0
Public Property Get testbound() As Variant
Attribute testbound.VB_Description = "test to see if I can bind(not my shorts!)  :-)"
Attribute testbound.VB_MemberFlags = "400"
  testbound = m_testbound
End Property

Public Property Let testbound(ByVal New_testbound As Variant)
  m_testbound = New_testbound
  PropertyChanged "testbound"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Refresh
Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
  UserControl.Refresh
End Sub

Private Sub mFont_FontChanged(ByVal PropertyName As String)
  Set UserControl.Font = mFont
  Refresh 'UserControl_Paint
End Sub

Private Function JustifyText(hdc As Long, strCaption As String) As Long
  
  'API's need UserControl.Width in Pixels not Twips
  Dim UserControlWidthPixels As Integer
  Dim UserControlHeightPixels As Integer
  'Hold amount of extra space to add to spaces bewteen words.
  Dim lngAmountToGrow As Long
    
  '***********************************
  'The Display/Print Justification logic is from the
  'book Programming Windows95 by Charles Petzold
  'In deference to Charles, the following spaghetti code
  'bears little resemblance to his original Justify Text
  'Function. Obviously you can't do a straight translation
  'from C to VB. Additionally I added several features.
  'Unfortunately the worst things I added were the 3 main
  'convoluted looping contructs. Hopefully I'll get a chance
  'to come back and rewrite them someday. If YOU rewrite the
  'Justification routines please EMAIL me a copy! :-)
  
  'How it works:
  'You'll see a lot of:
  
  'If Mid(pText, ctrT, 1) = vbCr Then Exit Do
  'This means we've just processed a Carriage Return so we need to
  'exit our Line processing Loop and go to the Print function.
  
  'If Mid(pText, ctrT, 1) = "" Then Exit Do
  'This means we've just processed a Zero Length string so we need to
  'exit our Line processing Loop and go to the Print function.
  'The Mid function will return this Zero Length String if we
  'ask for a starting position past the end of the string.
  'I'm using it like an End Of File indicator.
  
  
  'X & Y positions for TextOut call.
  Dim xStart As Integer
  Dim yStart As Integer
  
    
  'Number of SPACE chars in this line
  Dim iBreakCount As Integer
  
  'Counter for pText
  Dim ctrT As Integer

  'counter for last processed word position
  Dim ctrW As Integer
  
  'Junk holder for Return values we don't use
  Dim lngReturn As Long
  
  'UDT to hold Text Height and Width from API
  Dim lpSize As SIZE
  
  'Used when current output strings ends in a vbCrLf
  'or a zero length string"". Allows the
  'Text Justification and TextOut calls to not
  'print these non-printing characters. Basically Flags
  'that we don't include the very last character.
  Dim intCR As Integer
  
  'Holds ExtraLineSpacing property and
  'the height of the current Font.
  Dim intLineSpace As Integer
  
 'This is the actual Text string(Caption)
  Dim pText As String
  
  'Length of the entire string to be output.
  Dim CaptionLength As Integer
  
  'We do it like this because I need to modify
  'this function to accept specific lines to be
  'output..someday! :-)
  CaptionLength = Len(strCaption)
  pText = strCaption
  
  On Error GoTo MYHandler
  
  'Calculate Current UserControl.Width in Pixels
  UserControlWidthPixels = (UserControl.Width \ (1440 \ lngYdpi))
  UserControlHeightPixels = (UserControl.Height \ (1440 \ lngYdpi))
  
  'Need some error checking to make sure Margin
  'values will not be too large for the
  'UserControl's current Width and Height
  If MarginLeft >= UserControlWidthPixels Then MarginLeft = 0
  If MarginRight >= UserControlWidthPixels Then MarginRight = 0
  If (MarginLeft + MarginRight) >= UserControlWidthPixels Then
    MarginLeft = 0
    MarginRight = 0
  End If
  
  If MarginTop >= UserControlHeightPixels Then MarginTop = 0
  If MarginBottom >= UserControlHeightPixels Then MarginBottom = 0
  If (MarginTop + MarginBottom) >= UserControlHeightPixels Then
    MarginTop = 0
    MarginBottom = 0
  End If
  
  If Abs(ExtraLineSpacing) >= UserControlHeightPixels Then ExtraLineSpacing = 0
  
  'Finally calculate current settings.
  UserControlWidthPixels = UserControlWidthPixels - (MarginLeft + MarginRight)
  UserControlHeightPixels = UserControlHeightPixels - (MarginTop + MarginBottom)
  
  'We need lpsize.cy to add to yStart after printing
  'each line. We have to calculate this now because
  'the very first line might be a vbCrLf.
  'Also anytime we process a vbCrLf on a line by itself
  'we end up resetting lpsize.cy to 0.
  lngReturn = apiGetTextExtentPoint32(hdc, "A", 1, lpSize)
   intLineSpace = lpSize.cy + ExtraLineSpacing
  lpSize.cy = intLineSpace
  
  'Initialize for very first time through loop
    yStart = 0
    xStart = 0
    intCR = 0

'Keep processing until we have reached the last display line in the box
'This is the main Loop for the Entire Caption String
Do While yStart < (UserControlHeightPixels - lpSize.cy)
    
    'Counter for Current Character position in string
    ctrT = 1
    'Counter for character position of start of last word processed.
    'If our current Line width exceeds the Controls Width we
    'need to backup 1 word.
    ctrW = 1
    'Counter for how many spaces there are between words in
    'the current line we are processing.
    iBreakCount = 0
   
    
    'Strip leading space(s)
    Do While Mid(pText, ctrT, 1) = " "
        'Skip over blanks
        ctrT = ctrT + 1
        'Now we need to adjust the starting position of our
        'string as well. Like ptext++
        pText = Mid(pText, ctrT)
        ctrT = 1
    Loop
                   
    'Executed until the line length is wider than usercontrol.width
    Do While lpSize.cx < UserControlWidthPixels
       'Store postion of start of this word so that
       'when we have to backup one word so that
       'we have a new starting postion for output.
        If ctrT <> 1 Then
            ctrW = (ctrT - 1)
        End If
       
       Do While Mid(pText, ctrT, 1) <> " "
        If Mid(pText, ctrT, 1) = vbCr Then Exit Do
        If Mid(pText, ctrT, 1) = "" Then Exit Do
        ctrT = ctrT + 1
       Loop
  
        'If it's a vbCrLF then it's time to print! Exit main loop
        'Increment Breakcounter because we are exiting loop.
        If Mid(pText, ctrT, 1) = vbCr Then
            iBreakCount = iBreakCount + 1
            Exit Do
        End If
        
        'If it's a "" then it's time to print! Exit main loop
        'Increment Breakcounter because we are exiting loop.
        If Mid(pText, ctrT, 1) = "" Then
            iBreakCount = iBreakCount + 1
            Exit Do
        End If
        
        'If we get to here then we have not just processed a string
        'ending character of vbCrLf or "".
        'Normal processing of this Loop.
        iBreakCount = iBreakCount + 1
        
        lngReturn = apiSetTextJustification(hdc, 0, 0)
        lngReturn = apiGetTextExtentPoint32(hdc, Left(pText, ctrT), ctrT, lpSize)
        
        If lpSize.cx > UserControlWidthPixels Then Exit Do
        ctrT = ctrT + 1
    
    'While lpSize.cx < UserControlWidthPixels
    Loop
   
'***************************************************
    'Exiting Individual Line Loop
    'Clearout any error accumulated by previous calls
    'to apiSetTextJustification.
    lngReturn = apiSetTextJustification(hdc, 0, 0)
     
    'Let's get width of the current line
    lngReturn = apiGetTextExtentPoint32(hdc, Left(pText, ctrT), ctrT, lpSize)

   
   'OK DO Loop above is Main loop to break Caption into
   'individual lines. This happens when:
   '1) a vbCrLf is encountered
   '2) a ""(blank string) is encountered which Mid returns when EOF
   '3)Text is too long to fit on one line. Prepare to print the line - 1 word.
   'We need to backup 1 word to make the line fit.
  
   'Let's check and see if we got here through normal
   'normal processing not EOF or vbCrLf
            
    Select Case Mid(pText, ctrT, 1)
        Case vbCr
        'If Mid(pText, ctrT, 1) = vbCr Then
            If lpSize.cx > UserControlWidthPixels Then
                iBreakCount = iBreakCount - 1
                ctrT = ctrW
            End If
        

        Case ""
        'If Mid(pText, ctrT, 1) = "" Then
        If lpSize.cx > UserControlWidthPixels Then
            ctrT = ctrW
            iBreakCount = iBreakCount - 1
        End If
        
        'If we are here then its simply normal processing.
        'Our line length exceeded usercontrol width.
        'No vbCrLf or ""
        Case Else
        If Mid(pText, ctrT, 1) <> "" Then
            If Mid(pText, ctrT, 1) <> vbCr Then
                If lpSize.cx > UserControlWidthPixels Then
                    ctrT = ctrW
                    iBreakCount = iBreakCount - 1
                End If
            End If
        End If
    End Select

    'If string ends in a CR we have to backup one character when
    'we call any of our Text Api's
    If Mid(pText, ctrT, 1) = vbCr Then
        intCR = -1
    Else: intCR = 0
    End If
     
    'If string ends in a "" we have to backup one character when
    'we call any of our Text Api's
    If Mid(pText, ctrT, 1) = "" Then intCR = -1
     
    'Get ready to Print - Eliminate Trailing Blanks
    Do While Mid(pText, ctrT, 1) = " "
    ctrT = ctrT - 1
    iBreakCount = iBreakCount - 1
    Loop

    
    'Let's calculate new Text Extents.
    'Clearout any error accumulated by previous calls
    'to apiSetTextJustification.
    lngReturn = apiSetTextJustification(hdc, 0, 0)
    lngReturn = apiGetTextExtentPoint32(hdc, Left(pText, ctrT + intCR), ctrT + intCR, lpSize)

    'Calculate our xStart based on users selection
    'For Horizontal Alignment
    Select Case HAlignment

    Case Left_HAlign
        xStart = 0
  
    Case Right_HAlign
        xStart = UserControlWidthPixels - lpSize.cx
  
    Case Justify_HAlign
        xStart = 0
  
    Case Center_HAlign
        xStart = (UserControlWidthPixels - lpSize.cx) / 2
  
    Case Else
        MsgBox ("Error in Justification Selection" & vbCrLf & "Cannot Draw Text")
        Exit Function
    End Select

    
    'Here is the routine that produces the output.
    'We process & print 1 line at a time.
    'Let's check and make sure we are not outputting a single vbCrLf
    'or that we are at the end of the string("").
    If Mid(pText, ctrT, 1) <> vbCr Then
        If Mid(pText, ctrT, 1) <> "" Then
            If iBreakCount > 0 Then
                If HAlignment = Justify_HAlign Then
              
    'Normal processing we are wider than the usercontrol
    'If we got here ctrT shoudl never be <1
    If ctrT < 1 Then
        MsgBox ("ctrT =:" & ctrT)
        Exit Function
    End If
    
    'I'll leave this in, just in case someone
    'is really careful/paranoid. :-)
    'If iBreakCount < 1 Then
    'MsgBox ("Please increase Control Width")
    'Exit Function
    'End If
    lngReturn = apiSetTextJustification(hdc, 0, 0)
    lngAmountToGrow = UserControlWidthPixels - lpSize.cx
    lngReturn = apiSetTextJustification(hdc, lngAmountToGrow, iBreakCount)
    End If
        End If
            End If
                End If
        
    'Let's check and see if we are only outputting a sigle character
    'that is a vbCrLf.
    If ctrT <> 1 Then
        lngReturn = TextOut(hdc, xStart + MarginLeft, yStart + MarginTop, Left(pText, ctrT + intCR), ctrT + intCR)
    End If
     
    If Mid(pText, ctrT, 1) <> vbCr Then
        If ctrT = 1 Then
            lngReturn = TextOut(hdc, xStart + MarginLeft, yStart + MarginTop, Left(pText, ctrT), ctrT)
        End If
    End If
    
    'Start next line down 1 row.
    yStart = yStart + intLineSpace
   
    
    'Mid returns a zero length string "" if we go past the
    'string's boundary. If so exit main loop - all done!
    If Mid(pText, ctrT, 1) = "" Then Exit Do
        'If we ended on a vbCr then we need to skip the
        'character which is a vbLf
        If Mid(pText, ctrT, 1) = vbCr Then
            ctrT = ctrT + 1
        End If
    
    'Normal processing. Increment our string counter
    'to get ready to process next line.
    ctrT = ctrT + 1
    
    'Check and see if we've advanced past end of string.
    If Mid(pText, ctrT, 1) = "" Then Exit Do
    
    'Now we need to set a new starting postion in the string
    'to exclude what we have already printed.
    pText = Mid(pText, ctrT)
    
    'Reset our variables
    intCR = 0
    lpSize.cx = 0
    iBreakCount = 0
    
'While yStart < UserControlHeightPixels
'Keep looping until we've filled the box
Loop

'OK, we've now exited the Main Loop..we'er done! :-)
'Set return value to say everything is OK.
JustifyText = True
Exit Function

MYHandler:
'Add your own handlers here.
On Error Resume Next
JustifyText = False
End Function

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,2
Public Property Get MarginTop() As Integer
Attribute MarginTop.VB_ProcData.VB_Invoke_Property = "TextAttributes"
    MarginTop = Abs(m_MarginTop)
End Property

Public Property Let MarginTop(ByVal New_MarginTop As Integer)
    m_MarginTop = Abs(New_MarginTop)
    PropertyChanged "MarginTop"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,2
Public Property Get MarginBottom() As Integer
Attribute MarginBottom.VB_ProcData.VB_Invoke_Property = "TextAttributes"
    MarginBottom = Abs(m_MarginBottom)
End Property

Public Property Let MarginBottom(ByVal New_MarginBottom As Integer)
    m_MarginBottom = Abs(New_MarginBottom)
    PropertyChanged "MarginBottom"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,2
Public Property Get MarginLeft() As Integer
Attribute MarginLeft.VB_ProcData.VB_Invoke_Property = "TextAttributes"
    MarginLeft = Abs(m_MarginLeft)
End Property

Public Property Let MarginLeft(ByVal New_MarginLeft As Integer)
    m_MarginLeft = Abs(New_MarginLeft)
    PropertyChanged "MarginLeft"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,2
Public Property Get MarginRight() As Integer
Attribute MarginRight.VB_ProcData.VB_Invoke_Property = "TextAttributes"
    MarginRight = Abs(m_MarginRight)
End Property

Public Property Let MarginRight(ByVal New_MarginRight As Integer)
    m_MarginRight = Abs(New_MarginRight)
    PropertyChanged "MarginRight"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,2
Public Property Get MarginBox() As Integer
Attribute MarginBox.VB_MemberFlags = "400"
    MarginBox = Abs(m_MarginBox)
End Property

Public Property Let MarginBox(ByVal New_MarginBox As Integer)
    m_MarginBox = Abs(New_MarginBox)
    PropertyChanged "MarginBox"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get ExtraLineSpacing() As Integer
Attribute ExtraLineSpacing.VB_Description = "The amount of space to add between lines expressed in Pixels."
Attribute ExtraLineSpacing.VB_ProcData.VB_Invoke_Property = "TextAttributes"
    ExtraLineSpacing = m_ExtraLineSpacing
End Property

Public Property Let ExtraLineSpacing(ByVal New_ExtraLineSpacing As Integer)
    m_ExtraLineSpacing = New_ExtraLineSpacing
    PropertyChanged "ExtraLineSpacing"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get ParagraphIndent() As Integer
Attribute ParagraphIndent.VB_Description = "Sorry, not implemented yet! \r\n:-)"
Attribute ParagraphIndent.VB_ProcData.VB_Invoke_Property = "TextAttributes"
    ParagraphIndent = Abs(m_ParagraphIndent)
End Property

Public Property Let ParagraphIndent(ByVal New_ParagraphIndent As Integer)
    m_ParagraphIndent = New_ParagraphIndent
    PropertyChanged "ParagraphIndent"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=21,0,0,0
Public Property Get HAlignment() As text_HAlignment
Attribute HAlignment.VB_Description = "The control's horizontal alignment."
    HAlignment = m_HAlignment
End Property

Public Property Let HAlignment(ByVal New_HAlignment As text_HAlignment)
    m_HAlignment = New_HAlignment
    PropertyChanged "HAlignment"
End Property

